#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>


struct xtab { 	int 	src;
		char	*dst; };

struct ttab { 	char	*val;
		int	len; };

struct ttab 	ttable[256];

struct xtab	xtable[] = {	{	'',	"&auml;"	},
                         	{ 	'',	"&ouml;"	},
                         	{ 	'',	"&uuml;"	},
                         	{ 	'',	"&Auml;"	},
                         	{ 	'',	"&Ouml;"	},
                         	{ 	'',	"&Uuml;"	},
                         	{ 	'',	"&szlig;"	},
                         	{ 	'',	"&para;"	},
                         	{ 	'<',	"&lt;"		},
                         	{ 	'>',	"&gt;"		},
                         	{ 	'&',	"&amp;"		} };


int str2cmp (char *t1, char *t2)
{
    for (; (*t1 != '\0') && (*t2 != '\0'); t1++, t2++) {
        if ((isupper(*t1) ? tolower(*t1) : *t1) != 
            (isupper(*t2) ? tolower(*t2) : *t2))return 1;
    }
    return 0;
}

void remsl (char *t)
{
    char *p;

    for(p=t; *t != '\0'; t++) {
        if ((*t != '\\') || (*(t+1) != '-'))
            *p++ = *t;
    }
    *p = '\0';
}

char *rest (char *t, char *p)
{
    char *e;
/*
	look for matching prefix and skip over if found	
*/
    if (!str2cmp(t,p)) {
        t += strlen(p);
/*
	remove leading and trailing whitespace
*/
        while (*t == ' ' || *t == '\t') t++;
        e = t+strlen(t)-1;
        while (*e == ' ' || *e == '\t') *(e--) = '\0';
/*
	remove qoutes
*/
        if (((*t == '"') && (*e == '"')) ||
            ((*t == '\'') && (*e == '\''))) {
            *e = '\0';
            t++;
        }
    }
    return t;
}


char *xfgets(FILE *fp)
{
    static char line[8192], buf[8192];
    char *p, *q, *r;

    if (fgets(buf, sizeof(buf), fp) == NULL)
        return NULL;

    for (p = buf, q = line; *p != '\0'; p++) {
        r = ttable[(int)(*p)].val;
        if (r  == NULL)
            *q++ = *p;
        else {
            strcpy(q, r);
            q += ttable[(int)(*p)].len;
        }
    }
    *q = '\0';
    return line;

}


int main (int argc, char **argv)
{
    char *line, *tok, *tab;
    int ll, i, intp = 0, inname = 0, chnext = 0, table=0, tdc=0, inpre=0;

    memset(ttable, 0, sizeof(ttable));

    for (i = 0; i < (sizeof(xtable)/sizeof(xtable[0])); i++) {
        ttable[(int)xtable[i].src].val = xtable[i].dst;
        ttable[(int)xtable[i].src].len = strlen(xtable[i].dst);
    }
    
    printf ("<html><body>\n");

    while ((line = xfgets(stdin)) != NULL) {
        ll = strlen(line)-1;
        if (ll >= 0) line[ll] = '\0';
        remsl(line);
        if (chnext) chnext--;

        if (*line == '.') {
            if (inname) {
                printf("</i></h3>\n");
                inname = 0;
            }
        }
        else {
            if (strlen(line)) {
                if (*line == '\t') {
                    if (inpre)
                        printf("    %s \n",&line[1]);
                    else
                        printf("<tt><pre>    %s </pre></tt>\n",&line[1]);
                }
                else {
                    if ((tab=strchr(line,'\t')) != NULL) {
                        if (inname) {
                            *tab = '\0';
                            printf("<b>%s</b> - %s\n", line, tab+1);
                            continue;
                        }
                        if (!table) {
                            table = 1;
                            puts ("<table border=0>");
                        }
                        puts("<tr>");
                        for(tok=strtok(line,"\t"), tdc=0;
                            tok != NULL;
                            tok=strtok(NULL,"\t"), tdc++) {
                            if (tdc)
                                printf("<td>%s</td>\n",tok);
                            else
                                printf("<td><b>%s</b></td>\n",tok);
                        }
                        puts("</tr>");
                    }
                    else {
                        if (table) {
                            puts("</table>\n");
                            table = 0;
                        }
                        puts (line);
                    }
                }
            }
            else {
                if (table) {
                    puts("</table>\n");
                    table = 0;
                }
                if (inpre)
                    puts(" ");
                else
                    puts("<p>");
            }
            continue;
        }

        if (!str2cmp(line,".\\\"")) {
            printf("<!-- %s -->\n", rest(line,".\\\""));
            continue;
        }

        if (!str2cmp(line,".TP")) {
            if (intp) {
                printf("</dd>\n");
            }
            else {
                intp = 1;
                printf("<dl>\n");
            }
            chnext = 2;
            continue;
        }

        if (!str2cmp(line,".I")) {
            if (chnext) {
                printf("<dt><b>%s</b></dt>\n<dd>", rest(line,".I"));
                chnext = 0;
            }
            else {
                printf("<b>%s</b>\n", rest(line,".I"));
            }
            continue;
        }

        if (str2cmp(line,".BR") && !str2cmp(line,".B")) {
            if (chnext) {
                printf("<dt><b>%s</b></dt>\n<dd>", rest(line,".B"));
                chnext = 0;
            }
            else {
                printf("<i>%s</i>\n", rest(line,".B"));
            }
            continue;
        }

        if (*line == '.') {
            if (intp) { 
                printf("</dd>\n</dl>\n");
                intp = 0;
            }
        }

        if (!str2cmp(line,".SH NAME")) {
            printf("<h3>NAME <i>%s\n", rest(line,".SH NAME"));
            inname=1;
            continue;
        }
        if (!str2cmp(line,".SH")) {
            printf("<h3>%s</h3>\n", rest(line,".SH"));
            continue;
        }
        if (!str2cmp(line,".SS")) {
            printf("<h4>%s</h4>\n", rest(line,".SS"));
            continue;
        }
        if (!str2cmp(line,".BR")) {
            if (!table)
              printf("<br>\n%s\n", rest(line,".BR"));
            continue;
        }
        if (!str2cmp(line,".B")) {
            printf("<i>%s</i>\n", rest(line,".B"));
            continue;
        }
        if (!str2cmp(line,".I")) {
            printf("<b>%s</b>\n", rest(line,".I"));
            continue;
        }
        if (!str2cmp(line,".nf")) {
            printf("<tt><pre>\n");
            inpre = 1;
            continue;
        }
        if (!str2cmp(line,".fi")) {
            printf("</pre></tt>\n");
            inpre = 0;
            continue;
        }
    }
    if (table) printf ("</table>\n");
    printf ("</body></html>\n");
    return 0;
}
          
